; (A)s(S)mall(A)s(P)ossible SOFTWORKS presents       
; ... a 'BURRRN DA BYTEZ' production .........       
; ...... coded by C.HENZ in JULI 1998 ........       
; ......... DIGGER - the A86 source ..........       
; ............ see DIGGER.TXT for details ....       

START:

UNPACK_LEVEL:
        mov si,PACKED_LEVEL
        mov di,LEVEL

        mov dl,20H
UPLP1:
        mov cx,bx               ; bx=0000H
        mov dh,04H
UPLP2:
        mov al,[ds:si]
        shl al,cl
        shr al,06H
        inc ax                  ; al+=01H
        stosb

        inc cx                  ; cl+=02H
        inc cx

        dec dh
        jnz UPLP2

        inc si

        dec dx                  ; dl-=01H
        jnz UPLP1

        mov bp,dx               ; bp=Player X/Y=00H/00H
        mov [ds:si] B,06H       ; si=LEVEL, 06H = code for the player

        push 0B800H
        pop es

        mov ax,04DBH
        mov cx,2000
        xor di,di
        rep stosw

MAIN_LOOP:
                                ; check for rocks to drop and draw level...
        
        mov si,LEVEL

        xor di,di
        xor bx,bx

        mov cl,08H
DLLP1:
        mov dx,0010H       
DLLP2:
        mov al,[ds:si]
        mov ah,[ds:si+0010H]

        cmp al,04H              ; rock ?
        je S_ROCK            
        cmp al,05H        
        je F_ROCK               ; falling rock ?

DRAW_CHAR:
        mov bl,al
        mov al,[ds:bx+CHARS]    ; load char

        stosb

        inc di
        inc si

        dec dx
        jnz DLLP2

        add di,0080H

        loop DLLP1

        xchg ax,dx              ; dx=0000H
        int 16H

        mov dx,bp               ; dh=PlayerY,dl=PlayerX

        cmp ah,48H
        je MOVE_UP
        cmp ah,50H
        je MOVE_DOWN
        cmp ah,4BH
        je MOVE_LEFT
        cmp ah,4DH
        je MOVE_RIGHT

QUIT:
        ret                     ; return to OS

S_ROCK:
        cmp ah,ch               ; ch=00H
        je F_ROCK_F

        jmp DRAW_CHAR

F_ROCK:
        cmp ah,ch               ; ch=00H
        je F_ROCK_F

        cmp ah,06H              ; player below a falling rock ?
        je QUIT

        dec [ds:si] B           ; rock stops falling...
        jmp DRAW_CHAR

F_ROCK_F:
        mov [ds:si],ch          ; ch=00H
        mov [ds:si+0010H] B,05H
        mov al,ch               ; place to be drawn is now empty (ch=00H)
        jmp DRAW_CHAR


MOVE_UP:
        dec dh                  ; PlayerY > 0 ?
        js NO_MOVE
        jmp MOVE      

MOVE_DOWN:
        inc dh
        cmp dh,07H              ; PlayerY < 7 ?
        jg NO_MOVE
        jmp MOVE

MOVE_LEFT:
        dec dl                  ; PlayerX > 0 ?
        js NO_MOVE
        jmp MOVE

MOVE_RIGHT:
        inc dx                  ; dl+=01H
        cmp dl,0FH              ; PlayerX < 15 ?
        jg NO_MOVE

MOVE:
        mov bx,dx               ; calculate address in level-map
        shl bh,04H
        add bl,bh
        mov bh,ch               ; ch=00H
        

        cmp [ds:bx+LEVEL] B,02H ; free, gem or mud ?
        jg  NO_MOVE

        mov [ds:bx+LEVEL] B,06H ; update player pos. on the map

        xchg dx,bp              ; save new pos. to bp, get old pos. into dx

        mov bx,dx 
        shl bh,04H
        add bl,bh
        mov bh,ch               ; ch=00H

        mov [ds:bx+LEVEL],ch    ; erase old player pos. (ch=00H)

NO_MOVE:
        jmp MAIN_LOOP

CHARS:
        db ' '                  ; table with chars for level-drawing...
        db ''
        db '*'
        db ''
        db 'o'                  ; rock (04H)
        db 'o'                  ; falling rock (05H)
        db 1                    ; smiley - player char (06H)

PACKED_LEVEL:
                                ; the level, 2 bits are 1 tile...
                                ; 00XB = mud
                                ; 01XB = gem
                                ; 10XB = wall
                                ; 11XB = rock                                                                                

        db 00000000XB, 00000000XB, 00000000XB, 10111011XB
        db 00111111XB, 00000000XB, 00000000XB, 00010001XB
        db 11010101XB, 00000000XB, 00000000XB, 10011001XB
        db 01000000XB, 00000000XB, 11111111XB, 10011001XB
        db 11101010XB, 10100000XB, 01010101XB, 00000000XB
        db 01010101XB, 01101100XB, 10101010XB, 11111100XB
        db 01010101XB, 01000000XB, 00000000XB, 01010101XB
        db 10101010XB, 10101010XB, 10101010XB, 10101010XB

LEVEL:
                                ; the address where the level is
                                ; unpacked to...
                                ; psp+prog+level = 640 bytes = no problem.

